/*
 * typedef void (*PushAllRegistersCallback)(ThreadState*, intptr_t*);
 * extern "C" void PushAllRegisters(ThreadState*, PushAllRegistersCallback)
 */

.type PushAllRegisters, %function
.global PushAllRegisters
.hidden PushAllRegisters
PushAllRegisters:
        /* Push all callee-saves registers to get them
         * on the stack for conservative stack scanning.
         * Reserve space for callee-saved registers and return address.
         */
        addi sp,sp,-112
        /* Save the callee-saved registers and the return address. */
        sd ra,0(sp)
        sd s0,8(sp)
        sd s1,16(sp)
        sd s2,24(sp)
        sd s3,32(sp)
        sd s4,40(sp)
        sd s5,48(sp)
        sd s6,56(sp)
        sd s7,64(sp)
        sd s8,72(sp)
        sd s9,80(sp)
        sd s10,88(sp)
        sd s11,96(sp)
        /* Note: the callee-saved floating point registers do not need to be
         * copied to the stack, because fp registers never hold heap pointers
         * and so do not need to be kept visible to the garbage collector.
         * Pass the first argument untouched in a0 and the
         * stack pointer to the callback.
         */
        mv ra,a1
        mv a1,sp
        jalr ra
        /* Restore return address, adjust stack and return.
         * Note: the copied registers do not need to be reloaded here,
         * because they were preserved by the called routine.
         */
        ld ra,0(sp)
        addi sp,sp,112
        ret
.size PushAllRegisters, . - PushAllRegisters
